// Copyright 2007 Last.fm Ltd. under terms of GPL version 3
// Maintained by <max@last.fm>

#include <QWidget>
#include <QString>
class QLabel;
class QPushButton;
class QTimeLine;


/** The class will automatically animate itself into view after creation. */

class RestStateMessage : public QWidget
{	
	Q_OBJECT

public:
	RestStateMessage( class RestStateWidget* );

	void setMessage( const QString& );
	void setAcceptText( const QString& );
    void setFaqHref( const QString& );

signals:
    void moreHelpClicked();
    void accepted();

protected:
    virtual void paintEvent( QPaintEvent* );
    virtual void showEvent( QShowEvent* );

private slots:
    void onSlideStep( int );
    void onSlideFinished();

private:
    QTimeLine* m_timeline;

	struct
	{
        QLabel* icon;
		QLabel* text;
		QPushButton* accept;

	} ui;
};
