// Copyright 2007 Max Howell <mxcl@users.sf.net>
// Licence GPL2

#ifndef SPINNER_LABEL_H
#define SPINNER_LABEL_H

#include <QLabel>
#include <QMovie>
#include "containerutils.h" //FIXME remove by putting ctor in cpp file

class SpinnerLabel : public QLabel
{
    virtual bool event( QEvent* e )
    {
        switch ((int)e->type())
        {
            case QEvent::Hide:
                m_movie->setPaused( true );
                break;
            case QEvent::Show:
                m_movie->start();
                break;
        }
        
        return QLabel::event( e );
    }
    
    QMovie* m_movie;

public:
    SpinnerLabel( QWidget* parent = 0 ) : QLabel( parent )
    {
        setMovie( m_movie = new QMovie( dataPath( "progress.mng" ) ) );
        m_movie->setParent( this );
    }
};

#endif
