// Copyright 2007 Last.fm Ltd.
// Maintained by Max Howell <max@last.fm>
// Licensed by the GPL (version 2)

#include "lastfmtools_common.h"
#include <QString>

#ifdef __APPLE__
#   include "client/mac/handler/exception_handler.h"
#elif defined WIN32
#   include "client/windows/handler/exception_handler.h"
#elif defined __linux__
#   include "client/linux/handler/exception_handler.h"
#else
#   define NBREAKPAD
#endif


#ifndef NBREAKPAD
class MCEXP BreakPad : public google_breakpad::ExceptionHandler
{
    const char* m_product_name; // yes! It MUST be const char[]

public:
    BreakPad( const QString &dump_write_dirpath );
    ~BreakPad();

    void setProductName( const char* s ) { m_product_name = s; };
    const char* productName() const { return m_product_name; }
};
#endif


#undef char
